package gregapi.network;

import gregapi.block.IBlockExtendedMetaData;
import net.minecraft.block.Block;
import net.minecraft.world.IBlockAccess;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteArrayDataOutput;

/**
 * @author Gregorius Techneticies
 * 
 * Transmits the extended MetaData of a Block.
 */
public class PacketExtendedMetaData extends PacketCoordinates {
	public short mMetaData = 0;
	
	public PacketExtendedMetaData(int aDecoderType) {
		super(aDecoderType);
	}
	
	public PacketExtendedMetaData(int aX, int aY, int aZ, short aMetaData) {
		super(aX, aY, aZ);
		mMetaData = aMetaData;
	}
	
	@Override
	public byte getPacketIDOffset() {
		return -120;
	}
	
	@Override
	public ByteArrayDataOutput encode2(ByteArrayDataOutput aData) {
		aData.writeShort(mMetaData);
		return aData;
	}
	
	@Override
	public PacketCoordinates decode2(int aX, int aY, int aZ, ByteArrayDataInput aData) {
		return new PacketExtendedMetaData(aX, aY, aZ, aData.readShort());
	}
	
	@Override
	public void process(IBlockAccess aWorld) {
		if (aWorld != null) {
			Block tBlock = aWorld.getBlock(mX, mY, mZ);
			if (tBlock instanceof IBlockExtendedMetaData) ((IBlockExtendedMetaData)tBlock).setExtendedMetaData(aWorld, mX, mY, mZ, mMetaData);
		}
	}
}